sf94.actionDefs = {}


function sf94.addAction(def)
	sf94.actionDefs[def.id] = def
end

function sf94.setAction(p, action)
	if not p.sf94 then return end

	action.time = leveltime
	p.sf94.action = action
end


addHook("SpinSpecial", function(p)
	if not p.sf94 then return end

	if p.sf94.lastActionTime ~= nil
	and leveltime < p.sf94.lastActionTime + 2 then
		p.sf94.lastActionTime = leveltime
		return true
	end

	local action = p.sf94.action
	if not action then return end

	local actionDef = sf94.actionDefs[action.type]
	actionDef.action(p, action)

	p.sf94.lastActionTime = leveltime

	return true
end)

addHook("MapChange", function()
	for p in players.iterate do
		if p.sf94 then
			p.sf94.action = nil
		end
	end
end)
