freeslot("MT_SF94_SANTA_HAT")


function sf94.updateSantaHat(p)
	local hat = p.mo.hat

	if hat.valid then
		if p.panim == PA_ROLL or p.panim == PA_ABILITY then
			hat.state = S_SF94_SANTA_HAT_DOWN
		else
			hat.state = S_SF94_SANTA_HAT_UP
		end
	else
		p.mo.hat = nil
	end
end

function sf94.givePlayerSantaHat(p)
	local mo = p.mo
	if not (mo and mo.valid) or (mo.hat and mo.hat.valid) then
		return false
	end

	mo.hat = P_SpawnMobj(0, 0, 0, MT_OVERLAY)
	mo.hat.target = mo
	mo.hat.state = S_SF94_SANTA_HAT_UP

	return true
end
