-- Monitors respawning in SP and Co-op


freeslot("S_SF94_BOX_POP1", "S_SF94_MONITORRESPAWN")

function A_SF94_MonitorRemoved(item)
	if gametype ~= GT_COOP then return end

	local respawntime = CV_FindVar("respawnitemtime").value * TICRATE
	if respawntime == 0 then return end

	item.state = S_BOX_POP2
	item.tics = respawntime
end

function A_SF94_MonitorRespawn(item)
	P_SpawnMobj(item.x, item.y, item.z, item.type)
	P_RemoveMobj(item)
end

states[S_BOX_POP1].nextstate = S_SF94_BOX_POP1
states[S_BOX_POP2].nextstate = S_SF94_MONITORRESPAWN
states[S_SF94_BOX_POP1] = {SPR_NULL, A, 0, A_SF94_MonitorRemoved, 0, 0, S_BOX_POP2}
states[S_SF94_MONITORRESPAWN] = {SPR_NULL, A, 0, A_SF94_MonitorRespawn, 0, 0, S_NULL}
