addHook("MobjCollide", function(mo, pmo)
	if pmo.player
	and pmo.player.pflags & PF_SPINNING
	and pmo.z <= mo.z + mo.height and pmo.z + pmo.height >= mo.z then
		P_KillMobj(mo, pmo)
	end
end, MT_SNOWMAN)

addHook("MobjDeath", function(mo, destroyer)
	mo.state = S_XPLD1
	mo.scale = $ * 2
	mo.flags = $ & ~MF_SOLID & ~MF_PUSHABLE

	if destroyer and destroyer.valid then
		destroyer.color = SKINCOLOR_WHITE
	end

	return true
end, MT_SNOWMAN)
