-- Various utility functions


function sf94.randomElement(t)
	return t[P_RandomRange(1, #t)]
end

function sf94.arrayToSet(array)
	local set = {}
	for _, value in ipairs(array) do
		set[value] = true
	end
	return set
end

function sf94.getSectorsByTags(tags)
	local t = {}

	for s in sectors.iterate do
		for _, tag in ipairs(tags) do
			if type(tag) == "table" then
				if tag[1] <= s.tag and s.tag <= tag[2] then
					t[#t + 1] = s
				end
			elseif s.tag == tag then
				t[#t + 1] = s
			end
		end
	end

	return t
end
